#!/usr/bin/env node

const p = require("path");
const fs = require("fs");
const yaml = require("js-yaml");

const dir = process.argv[2] || ".";
const specs = loadTypesFromDir(dir);
const serialized = JSON.stringify(specs, null, 2);
const buildPath = process.argv[3] || "types.json";
fs.writeFileSync(buildPath, serialized);
console.log("Written " + buildPath);

function loadTypesFromDir(paths) {
  if (!Array.isArray(paths)) paths = [paths];
  const yamlPaths = [];
  for (const path of paths) {
    const list = fs.readdirSync(path);
    for (const filename of list) {
      if (filename.endsWith(".yml")) yamlPaths.push(p.join(path, filename));
    }
  }

  const yamls = [];
  for (const path of yamlPaths) {
    const buf = fs.readFileSync(path);
    const parsed = yaml.safeLoad(buf);
    yamls.push(parsed);
  }
  return yamls;
}

exports.keyseq = function (record) {
  return record.key + "@" + record.seq;
};
